using UnityEngine;
using System.Collections;
using UnityEngine.UI;

/*

	design:

	Stats:
	Age
	Wealth
	Skill
	Strength
	Excitement
	Self Acceptance
	

	Gateways:
	

	Jobs:
	Paper Route: Pays $1
	Garbage Man: Pays $5
	Novice Game Programmer: $10
	Gas Station: $15
	Store Clerk: $25
	

	Doctor: Pays $100
	Lawyer: Pays $120	
	Ultra Game Programmer: Pays $500
	
	Doors:
	
	Bully - Requires 24 strength to defeat
	Apartment Rent - Requires 7 Wealth to defeat
	Suicidal Thoughts - Requires 34 Self Acceptance and 14 Excitement to defeat
	Guilt from Parents - Requires 34 Self Acceptance
	Apathy - requires 24 Excitement to defeat
	Bordom - requires 34 Excitement to defeat
	Big Rocks - Requires 34 Strength to defeat
	Ancient Puzzle - Requries 38 Skill to defeat
	Wear bathing suit in public - Requires 5 Strength and 15 self acceptance
	Buy wedding ring - Requires 500 Wealth

	Five meaning of lifes to collect:

	- You accept your true self completely. Requires 100 self acceptance
	- You've reached stability and control in the areas where that is possible. Requires 10,000 wealth
	- You find total creative fulfillment. Requires 100 skill
	- You've found meaning in mastering your own biology. (> 100 strength)
	- You've found meaning in accepting unpredictability and Chaos.  Excitement > 100


	Activities: (all take time)


	Exercise - Adds 1 Strength
	Read a book - Adds 1 Skill
	Watch how to videos - Adds 1 Skill
	Take drugs - Adds 2 Excitement, Removes 1 Strength
	Murder someone - Adds 500 Wealth, Adds 10 Excitement,Removes 10 Self Acceptance
	Steal - Adds 50 Wealth, Adds 3 Excitement, Removes 3 Self Acceptance
	Love Someone - Adds 5 Excitement, Adds 5 Self Acceptance
	Care For Pet - Adds 1 Excitement, Adds 1 Self Acceptance
	Hang Glide - Adds 5 Excitement, Removes 20 Wealth


	Random Event:
	You are bullied in school.  You lose 5 Self Acceptance and Gain 1 Excitement.
	You gain weight.  You lose 3 Self Acceptance and lose 1 Strength.
	You lose weight.  You gain 3 Self Acceptance and gain 1 Strength.
	You meet someone special.  You gain 10 Self Acceptance.
	You get sick.  You lose 2 Strength.



	*/
public class Action : MonoBehaviour
{

	public string m_name;
	public Text m_text;
	public Image m_bar;
	float m_max = 10, m_cur = 10; //use full 1 increments, because that's one "push tick"
	float m_ageCost = 0.3f;
	float m_wealthMod = 0;
	float m_skillMod = 0;
	float m_reqSkill = 0;
	float m_reqStrength = 0;
	float m_strengthMod = 0;
	float m_selfMod = 0;
	float m_excitementMod = 0;
	float m_reqWealth = 0;
	float m_reqExcitement = 0;
	float m_reqSelf = 0;

	public Sprite m_job;
	public Sprite m_trophy;
	public Sprite m_lockedDoor;
	public Sprite m_randomEvent;
	public Sprite m_randomEventBad;

	public SpriteRenderer m_spriteRenderer;
	string m_finishText = "Error";
	float m_delayBetweenActivationsInSeconds = 0.1f;
	// Use this for initialization
	float m_lastColTime = 0;

	
	
	public enum eActionType
	{
		ACTION_NONE,
		ACTION_JOB,
		ACTION_GATEWAY,
		ACTION_MEANING,
		ACTION_EVENT
	}

	public eActionType m_type = eActionType.ACTION_NONE;

	void UpdateBar()
	{
		if (m_max == 1)
		{
			Transform t = m_bar.transform.parent;

			t.gameObject.active = false;
		}
		m_bar.fillAmount = m_cur / m_max;
	}

	public void SetupRandomActivity(float difficulty)
	{
		m_spriteRenderer.sprite = m_randomEvent;

		/*
		Exercise - Adds 1 Strength
Read a book -Adds 1 Skill
Watch how to videos - Adds 1 Skill
Take drugs - Adds 2 Excitement, Removes 1 Strength
Murder someone - Adds 500 Wealth, Adds 10 Excitement,Removes 10 Self Acceptance
    Steal - Adds 50 Wealth, Adds 3 Excitement, Removes 3 Self Acceptance
    Love Someone -Adds 5 Excitement, Adds 5 Self Acceptance
    Care For Pet - Adds 1 Excitement, Adds 1 Self Acceptance
    Hang Glide -Adds 5 Excitement, Removes 20 Wealth
	*/

		m_type = eActionType.ACTION_EVENT;

		string jobName = "Error";
		m_wealthMod = 0;
		m_reqSkill = 0;
		m_max= m_cur = 1;

		//Debug.Log("Diff: " + difficulty);
		int max = 9;

		if (difficulty < 0.7f) max = 6;
		if (difficulty < 0.4f) max = 3;

		int r = Random.Range((int)0, max);

		switch (r)
		{
			case 0:
				jobName = "Love Someone";
				m_excitementMod = Random.Range((int)1, 3);
				m_selfMod = Random.Range((int)3, 7);
				m_finishText = "It's nice having someone to love.";
				break;

			case 1:
				jobName = "Exercise";
				m_strengthMod = Random.Range((int)2, 4);
				m_selfMod = Random.Range((int)2, 4);
				m_finishText = "You get healthier by exercising.";
				break;

			case 2:
				jobName = "Read a book";
				m_skillMod = Random.Range((int)4, 7);
				m_excitementMod = Random.Range((int)1, 2);
				m_finishText = "Your skill is increased by reading a book.";
				break;

			case 3:
				jobName = "Play";
				m_excitementMod = Random.Range((int)3, 7);
				m_selfMod = Random.Range((int)2, 4);
				m_finishText = "Playing makes your life more exciting.";

				break;
		

			case 4:
				jobName = "Care for pet";
				m_excitementMod = 2;
				m_selfMod = 2;
				m_reqWealth = 1;
				m_finishText = "You care for a pet.";
				break;

			case 5:
				jobName = "Steal Purse";
				m_excitementMod = 7;
				m_selfMod = -4;
				m_wealthMod = 50;
				m_finishText = "You steal $" + m_wealthMod + ". Your Self Acceptance decreases.";
				m_spriteRenderer.sprite = m_randomEventBad;


				break;

			case 6:
				jobName = "Hang glide";
				m_excitementMod = 12;
				m_selfMod = 3;
				m_finishText = "Your life is made more exciting by doing something dangerous.";
				m_reqWealth = 10;
				m_reqStrength = 25;

				break;
			case 7:
				jobName = "Take drugs";
				m_cur = m_max = 1;
				m_excitementMod = 7;
				m_strengthMod = -4;
				m_finishText = "Your life is more exciting by taking drugs. You feel less healthy.";
				m_spriteRenderer.sprite = m_randomEventBad;

				break;

			case 8:
				jobName = "Murder Someone";
				m_excitementMod = 10;
				m_selfMod = -30;
				m_wealthMod = 500;
				m_reqStrength = 30;
				m_finishText = "You commit murder and steal $" + m_wealthMod + ". Your Self Acceptance decreases greatly.";
				m_spriteRenderer.sprite = m_randomEventBad;

				break;
		}

		float randomModA = Random.Range(1.0f, 1 + difficulty);
		float randomModB = Random.Range(1.0f, 1 + difficulty);
		float randomModC = Random.Range(1.0f, 1 + difficulty);

		m_wealthMod *= randomModC;
		m_strengthMod *= randomModA;
		m_skillMod *= randomModA;
		m_excitementMod *= randomModB;
		m_selfMod *= randomModB;
		m_reqSkill *= randomModB;
		m_reqWealth *= randomModB;
		m_wealthMod = Mathf.RoundToInt(m_wealthMod);
		m_reqWealth = Mathf.RoundToInt(m_reqWealth);
		//m_strengthMod = Mathf.RoundToInt(m_strengthMod);
		m_reqSkill = Mathf.RoundToInt(m_reqSkill);
		//m_selfMod = Mathf.RoundToInt(m_strengthMod);

		string gives ="";

		/*
		if (m_wealthMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_wealthMod) + " Wealth";
		}

		if (m_strengthMod > 0)
		{
			gives += "Gives " + RTUtil.RoundToTwoDec(m_strengthMod) + " Physical";
		}

		if (m_skillMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_skillMod) + " Skill";
		}

		if (m_excitementMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_excitementMod) + " Excitement";
		}

		if (m_selfMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_selfMod) + " Self Acceptance";
		}

		if (m_strengthMod < 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Removes " + RTUtil.RoundToTwoDec(-m_strengthMod) + " Physical";
		}

		if (m_selfMod < 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Removes " + RTUtil.RoundToTwoDec(-m_selfMod) + " Self Acceptance";
		}
		*/

		if (m_reqStrength > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqStrength) + " Physical";
		}

		if (m_reqWealth > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqWealth) + " Wealth";
		}

		m_text.text = "" + jobName + "\n"+gives;
		UpdateBar();
	}

	public void SetupRandomJob(float difficulty)
	{

		m_spriteRenderer.sprite = m_job;
		m_type = eActionType.ACTION_JOB;

		string jobName = "Error";
		m_wealthMod = 0;
		m_reqSkill = 0;
		m_skillMod = 0.1f;

		//Debug.Log("Diff: " + difficulty);
		int max = 9;

		if (difficulty < 0.7f) max = 6;
		if (difficulty < 0.4f) max = 3;

		int r = Random.Range((int)0, max);

		switch(r)
		{
			case 0:
				jobName = "Paper Route";
				m_wealthMod = 15;
				m_reqSkill = 0;
				m_skillMod = 1;
				m_strengthMod = 0.5f;
				m_selfMod = 0.2f;
				m_finishText = "You deliver papers to earn some spending cash.";

				break;

			case 1:
				jobName = "Cleaning toilets";
				m_wealthMod = 40;
				m_reqSkill = 2;
				m_skillMod = 0.5f;
				m_strengthMod = 0.5f;
				m_selfMod = 0.1f;

				m_finishText = "You work as a bathroom janitor.";
				break;

			case 2:
				jobName = "Garbage Man";
				m_wealthMod = 70;
				m_reqSkill = 8;
				m_skillMod = 0.5f;
				m_finishText = "You operate a garbage route.";
				m_strengthMod = 0.5f;
				m_selfMod = 0.1f;

				break;

			case 3:
				jobName = "Indie Game Programmer";
				m_wealthMod = 40;
				m_reqSkill = 15;
				m_skillMod = 1;
				m_excitementMod = 1;
				m_selfMod = 0.5f;
				m_finishText = "You make indie games. It's hard but you learn Skills quicker.";
			
				break;

			case 4:
				jobName = "Soup Kitchen";
				m_wealthMod = 0;
				m_reqSkill = 0;
				m_selfMod = 1;
				m_skillMod = 0.1f;
				m_finishText = "You donate time to help out people. No pay, but your Self Acceptance increases.";
				
				break;

			case 5:
				jobName = "Store Clerk";
				m_wealthMod = 80;
				m_reqSkill = 8;
				m_skillMod = 1;
				m_finishText = "You work as a store clerk.";
				m_selfMod = 0.1f;
				break;

			case 6:
				jobName = "Medical Doctor";
				m_wealthMod = 150;
				m_reqSkill = 65;
				m_skillMod = 0.5f;
				m_finishText = "You are a Doctor.";
				m_selfMod = 0.5f;
				break;

			case 7:
				jobName = "IP Lawyer";
				m_wealthMod = 200;
				m_reqSkill = 55;
				m_skillMod = 0.5f;
				m_finishText = "You are an IP Lawyer";
				break;

			case 8:
				jobName = "Ultra Game Programmer";
				m_wealthMod = 300;
				m_reqSkill = 95;
				m_skillMod = 0.5f;
				m_finishText = "You are an Ultra Game Programmer.";
				m_excitementMod = 2;
				m_selfMod = 2;
				break;
		}

		float randomModA = Random.Range(1.0f, 1 + difficulty);
		float randomModB = Random.Range(1.0f, 1 + difficulty);
		m_wealthMod *= randomModA;
		m_reqSkill *= randomModB;
		
		m_wealthMod = Mathf.RoundToInt(m_wealthMod);
		m_reqSkill = Mathf.RoundToInt(m_reqSkill);

		string reqs = "";

		if (m_reqSkill > 1)
		{
			reqs = "Requires " + m_reqSkill + " Skill";
		}

		m_text.text = "Job: " + jobName + "\nPays $" + m_wealthMod + " " + reqs;
		UpdateBar();
	}

	public void SetupRandomGateway(float difficulty)
	{
		m_spriteRenderer.sprite = m_lockedDoor;
		m_type = eActionType.ACTION_GATEWAY;

		/*
		Bully - Requires 24 strength to defeat
		Apartment Rent - Requires 7 Wealth to defeat
		Suicidal Thoughts - Requires 34 Self Acceptance and 14 Excitement to defeat
		Guilt from Parents -Requires 34 Self Acceptance
		Apathy - requires 24 Excitement to defeat
		Bordom - requires 34 Excitement to defeat
		Big Rocks - Requires 34 Strength to defeat
		Ancient Puzzle - Requries 38 Skill to defeat
		Wear bathing suit in public - Requires 5 Strength and 15 self acceptance
		Buy wedding ring - Requires 500 Wealth
		*/
		string jobName = "Error";
		m_wealthMod = 0;
		m_reqSkill = 0;
		m_cur = m_max = 1;

		m_selfMod = 1;
		m_skillMod = 1;
		m_excitementMod = 3;
		m_strengthMod = 1;


		//Debug.Log("Diff: " + difficulty);
		int max = 9;

		if (difficulty < 0.5f) max = 6;

		int r = Random.Range((int)0, max);


		switch (r)
		{

			case 0:
				jobName = "Boredom";
				m_reqExcitement = 10;
				m_finishText = "You're always able to find something new and interesting to do.";
				break;

			case 1:
				jobName = "Wear bathing suit in public";
				m_reqSelf = 15;
				m_reqStrength = 5;
				m_finishText = "You feel comfortable wearing a bathing suit in public.";
				break;

			case 2:
				jobName = "Fight Bully";
				m_reqStrength = 19;
				m_selfMod = 5;
				m_finishText = "You defeat a bully.";
				break;

			case 3:
				jobName = "Guilt from Parents";
				m_reqSelf = 15;
				m_finishText = "You're able to ignore the complaints from your parents with a smile.";
				break;

			case 4:
				jobName = "Apathy";
				m_reqSelf = 25;
				m_finishText = "You find enough beauty in the world to get up today.";
				break;

			case 5:
				jobName = "Big Rocks";
				m_reqStrength = 30;
				m_finishText = "Your physical ability allows you to move the rocks standing in your path.";
				break;
				

			case 6:

				jobName = "Apartment Rent";
				m_reqWealth = 45;
				m_wealthMod = -m_reqWealth;
				m_finishText = "You pay $" + m_reqWealth + " for your apartment.";
				break;

			case 7:
				jobName = "Suicidal Thoughts";
				m_reqSelf = 30;
				m_finishText = "You know your life has value and don't listen to the dark thoughts.";
				break;


			case 8:
				jobName = "Puzzle";
				m_reqSkill = 35;
				m_finishText = "Your Skills allow you to solve a puzzle standing in your way.";
				break;
		}

		float randomModA = Random.Range(1.0f, 1 + difficulty);
		float randomModB = Random.Range(1.0f, 1 + difficulty);
		float randomModC = Random.Range(1.0f, 1 + difficulty);

		m_wealthMod *= randomModC;
		m_reqWealth *= randomModC;

		m_strengthMod *= randomModA;
		m_skillMod *= randomModA;
		m_excitementMod *= randomModB;
		m_selfMod *= randomModB;
		m_reqSkill *= randomModB;
		m_reqStrength *= randomModB;

		m_wealthMod = Mathf.RoundToInt(m_wealthMod);
		m_reqWealth = Mathf.RoundToInt(m_reqWealth);
		//m_strengthMod = Mathf.RoundToInt(m_strengthMod);
		m_reqSkill = Mathf.RoundToInt(m_reqSkill);
		m_reqStrength = Mathf.RoundToInt(m_reqStrength);
		//m_selfMod = Mathf.RoundToInt(m_strengthMod);

		string gives = "";

		/*
		if (m_wealthMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_wealthMod) + " Wealth";
		}


		if (m_strengthMod > 0)
		{
			gives += "Gives " + RTUtil.RoundToTwoDec(m_strengthMod) + " Strength";
		}

		if (m_skillMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_skillMod) + " Skill";
		}

		if (m_excitementMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_excitementMod) + " Excitement";
		}

		if (m_selfMod > 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Gives " + RTUtil.RoundToTwoDec(m_selfMod) + " Self Acceptance";
		}

		if (m_strengthMod < 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Removes " + RTUtil.RoundToTwoDec(-m_strengthMod) + " Strength";
		}

		if (m_selfMod < 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "Removes " + RTUtil.RoundToTwoDec(-m_selfMod) + " Self Acceptance";
		}
		*/

		if (m_reqStrength > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqStrength) + " Physical";
		}

		if (m_reqWealth > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqWealth) + " Wealth";
		}

		if (m_reqSelf > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqSelf) + " Self Acceptance";
		}


		if (m_reqExcitement > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqExcitement) + " Excitement";
		}


		if (m_reqSkill > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqSkill) + " Skill";
		}


		/*
		if (m_wealthMod < 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "removes " + RTUtil.RoundToTwoDec(-m_wealthMod) + " Wealth";
		}
		*/

		m_text.text = "" + jobName + " - " + gives+" to defeat";
		UpdateBar();

	}


	public void SetupMeaning(int meaningNum)
	{
		m_spriteRenderer.sprite = m_trophy;
		m_cur = m_max = 1;
		m_type = eActionType.ACTION_MEANING;

		
		string jobName = "Meaning";

		switch (meaningNum)
		{

			case 0:
				m_finishText = "You've found meaning in accepting who you are completely.";
				m_reqSelf = 75;
				break;

			case 1:
				m_finishText = "You've found meaning in the work you do.";
				m_reqSkill = 75;
				break;

			case 2:
				m_finishText = "You've found meaning in mastering your own biology.";
				m_reqStrength = 75;
				break;

			case 3:
				m_finishText = "You've found meaning in accepting unpredictability and chaos.";
				m_reqExcitement = 75;
				break;

			case 4:
				m_finishText = "You've found meaning in financial stability and responsibility.";
				m_reqWealth = 5000;
				break;
		}


		string gives = "";

		if (m_reqStrength > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqStrength) + " Physical";
		}

		if (m_reqWealth > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqWealth) + " Wealth";
		}

		if (m_reqSelf > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqSelf) + " Self Acceptance";
		}


		if (m_reqExcitement > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqExcitement) + " Excitement";
		}

		if (m_reqSkill > 0)
		{
			if (gives.Length > 0) gives += " and ";
			gives += "Requires " + RTUtil.RoundToTwoDec(m_reqSkill) + " Skill";
		}

		/*
		if (m_wealthMod < 0)
		{
			if (gives.Length > 0) gives += ", ";
			gives += "removes " + RTUtil.RoundToTwoDec(-m_wealthMod) + " Wealth";
		}
		*/

		m_text.text = "" + jobName + " - " + gives + " to achieve.";
		UpdateBar();

	}

	void Start ()
	{
		//SetupRandomGateway(0.1f);
		//SetupRandomActivity(0.1f);
		UpdateBar();
	}
	
	// Update is called once per frame
	void Update ()
	{
	}
	
	void OnDie()
	{
		GameObject.Destroy(gameObject, 0);
	}

	bool CheckIfFailed()
	{
		bool bFailed = false;

		string failText = "";


		if (m_reqSkill > GameLogic.Get().GetPlayerData().GetSkill())
		{
			GameLogic.Get().GetPlayerData().FailSkill();
			bFailed = true;
			failText = "You lack the Skill to do this.";
        }

		if (m_reqStrength > GameLogic.Get().GetPlayerData().GetStrength())
		{
			GameLogic.Get().GetPlayerData().FailStrength();
			bFailed = true;
			failText = "You lack the Strength to do this.";
		}

		if (m_reqWealth > GameLogic.Get().GetPlayerData().GetWealth())
		{
			GameLogic.Get().GetPlayerData().FailWealth();
			bFailed = true;
			failText = "You lack the Wealth to do this.";

		}
		if (m_reqExcitement > GameLogic.Get().GetPlayerData().GetExcitement())
		{
			GameLogic.Get().GetPlayerData().FailExcitement();
			bFailed = true;
			failText = "You lack the Excitement in your life to do this.";

		}
		if (m_reqSelf > 0 && m_reqSelf > GameLogic.Get().GetPlayerData().GetSelf())
		{
			GameLogic.Get().GetPlayerData().FailSelf();
			failText = "You lack the Self Acceptance to do this.";

			bFailed = true;
		}

		if (failText.Length > 0)
		{
			GameLogic.Log(failText);

		}
		return bFailed;
	}

	void OnAction()
	{
		if (m_cur <= 0)
		{
			return;
		}


		
		if (CheckIfFailed())
		{
			RTAudioManager.Get().Play("fail");
			return;
		}
	
		
		int totalMeanings = GameLogic.Get().GetPlayerScript().m_totalMeanings;

		switch (m_type)
		{
		
			
			case eActionType.ACTION_MEANING:

				GameLogic.Get().GetPlayerScript().m_meaningsFound++;
				m_finishText += " (" + GameLogic.Get().GetPlayerScript().m_meaningsFound + " of " +
					totalMeanings + " found)";

				break;
		}

		

		GameLogic.Log(m_finishText);
		m_cur -= 1;
		GameLogic.Get().GetPlayerData().ModAge(m_ageCost);
		GameLogic.Get().GetPlayerData().ModWealth(m_wealthMod);
		GameLogic.Get().GetPlayerData().ModStrength(m_strengthMod);
		GameLogic.Get().GetPlayerData().ModSelf(m_selfMod);
		GameLogic.Get().GetPlayerData().ModSkill(m_skillMod);
		GameLogic.Get().GetPlayerData().ModExcitement(m_excitementMod);

		UpdateBar();


		if (m_type == eActionType.ACTION_MEANING)
		{

			if (GameLogic.Get().GetPlayerScript().m_meaningsFound == totalMeanings)
			{
				GameLogic.Log("CONGRATULATIONS! You've mastered every facet of your life before death. Was it luck or due to the choices you made?  Can we ever really know? (GAME OVER)");
			}
		}

		//no power left.. uh, destroy us?
		if (m_cur <= 0)
		{


			switch (m_type)
			{
				case eActionType.ACTION_GATEWAY:
					RTAudioManager.Get().Play("gate_open");
					break;

				case eActionType.ACTION_EVENT:
					RTAudioManager.Get().Play("hit");
					break;

				case eActionType.ACTION_JOB:
					RTAudioManager.Get().Play("cash_register");
					break;


				case eActionType.ACTION_MEANING:
					RTAudioManager.Get().Play("meaning");
					break;
			}
			OnDie();


		}
		else
		{

			RTAudioManager.Get().Play("click");

		}

	}

	void OnTriggerStay2D(Collider2D col)
	{
		if (m_lastColTime < Time.time)
		{
			//col.attachedRigidbody.AddForce(-0.1F * col.attachedRigidbody.velocity);
			//Debug.Log(col.over);
			m_lastColTime = Time.time + m_delayBetweenActivationsInSeconds;
			OnAction();
		}
        
	}
}
