using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Text;

public class RTUtil
{

	public static byte[] g_buffer = new byte[1024*50];
	public static int[] g_intArray = new int[1];
	public static short[] g_shortArray = new short[1];
	public static float[] g_floatArray = new float[3];

    private static StringBuilder AppendColor(StringBuilder sb, int r, int g, int b, int alpha)
    {
        sb.Append("<color=#" + r.ToString("x2") + g.ToString("x2") + b.ToString("x2") + alpha.ToString("x2") + ">");
        //sb.Append("<color=#0000ffff>");
        
        return sb;
    }

	public static float RoundToOneDec(float f)
	{
		return Mathf.Round(f * 10) / 10;
	}
	public static float RoundToTwoDec(float f)
	{
		return Mathf.Round(f * 100) / 100;
	}

	public static string ConvertSansiToUnityColors(string s)
    {
       
        System.Text.StringBuilder sb = new System.Text.StringBuilder("");
        int colorDepth = 0;

        for (int i = 0; i < s.Length; i++)
        {
            if (s[i] == '`')
            {
                //found special code
                if (s.Length-1 > i)
                {
                    i++; //move it past the second control code
              
                    if (s[i] == '`')
                    {
                        if (colorDepth > 0)
                        {
                            sb.Append("</color>");
                            colorDepth--;
                        }
                        continue;
                    }

                   colorDepth++;
                    //enough room for a code here
                    if (s[i] == '0')
                    {
                        AppendColor(sb, 255, 255, 255, 255);
                        continue;
                    }
                    if (s[i] == '1')
                    {
                        AppendColor(sb, 173, 244, 255, 255);
                        continue;
                    }
                    if (s[i] == '2')
                    {
                        AppendColor(sb, 73, 252, 0, 255);
                        continue;
                    }
                    if (s[i] == '3')
                    {
                        AppendColor(sb, 191, 218, 255, 255);
                        continue;
                    }
                    if (s[i] == '4')
                    {
                        AppendColor(sb, 255, 39, 29, 255);
                        continue;
                    }
                    if (s[i] == '5')
                    {
                        AppendColor(sb, 235, 183, 255, 255);
                        continue;
                    }
                    if (s[i] == '6')
                    {
                        AppendColor(sb, 255, 202, 111, 255);
                        continue;
                    }
                    if (s[i] == '7')
                    {
                        AppendColor(sb, 230, 230, 230, 255);
                        continue;
                    }
                    if (s[i] == '8')
                    {
                        AppendColor(sb, 255, 148, 69, 255);
                        continue;
                    }
                    if (s[i] == '9')
                    {
                        AppendColor(sb, 255, 238, 12, 255);
                        continue;
                    }
                    if (s[i] == '!')
                    {
                        AppendColor(sb, 209, 255, 249, 255);
                        continue;
                    }
                    if (s[i] == '@')
                    {
                        AppendColor(sb, 255, 205, 201, 255);
                        continue;
                    }
                    if (s[i] == '#')
                    {
                        AppendColor(sb, 255, 143, 243, 255);
                        continue;
                    }
                    if (s[i] == '$')
                    {
                        AppendColor(sb, 255, 252, 197, 255);
                        continue;
                    }
                    if (s[i] == '^')
                    {
                        AppendColor(sb, 181, 255, 151, 255);
                        continue;
                    }
                    if (s[i] == '&')
                    {
                        AppendColor(sb, 254, 235, 255, 255);
                        continue;
                    }
                    if (s[i] == 'w')
                    {
                        AppendColor(sb, 255, 255, 255, 255);
                        continue;
                    }
                    if (s[i] == 'o')
                    {
                        AppendColor(sb, 252, 230, 186, 255);
                        continue;
                    }
                    if (s[i] == 'b')
                    {
                        AppendColor(sb, 0, 0, 0, 255);
                        continue;
                    }
                    if (s[i] == 'p')
                    {
                        AppendColor(sb, 255, 223, 241, 255);
                        continue;
                    }
                  


                    //uh oh, unknown color code
                    colorDepth--; //Remove the one we had added earlier
                    continue;
                }
            }
            sb.Append(s[i]);
        }

        while (colorDepth > 0)
        {
            colorDepth--;
            sb.Append("</color>");
        }
        return sb.ToString();
    }
	//write
	public static void SerializeString(string value, byte[] byteBuff, ref int index)
	{

		//first write the size of it
		SerializeInt32(value.Length, byteBuff, ref index); 

		//now write the actual string data
		//OPTIMIZE - couldn't we do this without allocating new data here?
		byte[] stringBuff = Encoding.ASCII.GetBytes(value);

		System.Buffer.BlockCopy(stringBuff, 0, byteBuff, index, value.Length); 
		index += value.Length;
	}

	//read
	public static void SerializeString(ref string value, byte[] byteBuff, ref int index)
	{
	//first get the size
		int tempInt = 0;
		SerializeInt32(ref tempInt, byteBuff, ref index); 
		
		value = System.Text.Encoding.Default.GetString (byteBuff, index, tempInt);
		index += tempInt;
	}

	//write
	public static void SerializeInt32(int value, byte[] byteBuff, ref int index)
	{
		g_intArray[0] = value;
		System.Buffer.BlockCopy(g_intArray, 0, byteBuff, index, 4); //raw copy over 4 bytes
		index += 4;
	}

	//read
	public static void SerializeInt32(ref int value, byte[] byteBuff, ref int index)
	{
		System.Buffer.BlockCopy(byteBuff, index, g_intArray, 0, 4); //raw copy over 4 bytes
		value = g_intArray[0];
		index += 4;
	}

	//write
	public static void SerializeInt16(short value, byte[] byteBuff, ref int index)
	{
		g_shortArray[0] = value;
		System.Buffer.BlockCopy(g_shortArray, 0, byteBuff, index, 2); //raw copy over 4 bytes
		index += 2;
	}
	
	//read
	public static void SerializeInt16(ref short value, byte[] byteBuff, ref int index)
	{
		System.Buffer.BlockCopy(byteBuff, index, g_shortArray, 0, 2); //raw copy over 4 bytes
		value = g_shortArray[0];
		index += 2;
	}

	//write
	public static void SerializeFloat(float value, byte[] byteBuff, ref int index)
	{
		g_floatArray[0] = value;
		System.Buffer.BlockCopy(g_floatArray, 0, byteBuff, index, 4); //raw copy over 4 bytes
		index += 4;
	}
	
	//read
	public static void SerializeFloat(ref float value, byte[] byteBuff, ref int index)
	{
		System.Buffer.BlockCopy(byteBuff, index, g_floatArray, 0, 4); //raw copy over 4 bytes
		value = g_floatArray[0];
		index += 4;
	}

	//write
	public static void SerializeVector2(Vector2 value, byte[] byteBuff, ref int index)
	{
		g_floatArray[0] = value.x;
		g_floatArray[1] = value.y;
		System.Buffer.BlockCopy(g_floatArray, 0, byteBuff, index, 8); 
		index += 8;
	}
	
	//read
	public static void SerializeVector2(ref Vector2 value, byte[] byteBuff, ref int index)
	{
		System.Buffer.BlockCopy(byteBuff, index, g_floatArray, 0, 8); 
		value.x = g_floatArray[0];
		value.y = g_floatArray[1];
		index += 8;
	}

	public static Vector2 Vector2Lerp(Vector2 from, Vector2 to, float t)
	{
		return new Vector2(from.x - ((from.x - to.x) * t), from.y - ((from.y - to.y) * t));
	}

	//Stolen from here:  http://forum.unity3d.com/threads/12949-transform-Find-doesn-t-work
	public static GameObject FindInChildren(GameObject go, string name)
	{
		return (from x in go.GetComponentsInChildren<Transform>()
		        
		        where x.gameObject.name == name
		        select x.gameObject).First();
	}
}
